#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.evaluation.av.evtype import evtype
from bu4.evaluation.constructs.eindexed import EIndexed
from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.evaluation.constructs.evalue import EValue
from bu4.evaluation.targets.avtarget import AVTarget
from bu4.indexing.constructs.indexed import Indexed

__all__ = ('AVICall',)


class AVICall(AVTarget):
    def __init__(self, ev: evtype, argument: Indexed):
        self.ev = ev
        self.argument = argument

    def given(self, value: EValue) -> Evaluable:
        return value.call(EIndexed(self.ev, self.argument))

    def __str__(self):
        return f'({self.argument})'
