#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.indexing.constructs.indexed import Indexed
from bu4.indexing.states.afterindexing import AfterIndexing
from bu4.indexing.states.indexingfinished import IndexingFinished
from bu4.indexing.states.indexinglinked import IndexingLinked
from bu4.indexing.states.indexingstate import IndexingState
from bu4.indexing.targets.aichain import AIChain

__all__ = ('index_finish',)


def _afterindexing_iteration(state: AfterIndexing) -> IndexingState:
    if isinstance(state.state, IndexingFinished):
        state = state.target.given(state.state.indexed)
    elif isinstance(state.state, AfterIndexing):
        state.state, state.target = state.state.state, AIChain(state.state.target, state.target)
    elif isinstance(state.state, IndexingLinked):
        state.state = state.state.linked.index(state.state.promise)
    else:
        raise TypeError
    return state


def index_finish(state: IndexingState) -> Indexed:
    while True:
        if isinstance(state, IndexingFinished):
            return state.indexed
        elif isinstance(state, AfterIndexing):
            state = _afterindexing_iteration(state)
        else:
            raise TypeError
