#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.evaluation.constructs.evalue import EValue
from bu4.evaluation.sync import sync
from bu4.indexing.index_finish import index_finish
from bu4.linking.link_finish import link_finish
from bu4.parsing.toolchain.parse import parse
from bu4.parsing.toolchain.stdext import standard_extension
from bu4.parsing.toolchain.transply import transply

__all__ = ('isynced',)


def isynced(source: str) -> EValue:
    bsource = transply(source)
    parsed = parse(bsource, standard_extension)
    linked = link_finish(parsed.link(set()))
    indexed = index_finish(linked.index([]))
    evaluable = indexed.evaluable([])
    return sync(evaluable)
