#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.parsing.codes import CODE_MAKE
from bu4.parsing.constructs.plambda import PLambda
from bu4.parsing.extensions.extension import Extension
from bu4.parsing.states.parsingstate import ParsingState
from bu4.parsing.states.afterparsing import AfterParsing
from bu4.parsing.states.parsingfinished import ParsingFinished
from bu4.parsing.states.parsingread import ParsingRead

__all__ = ('XMake',)

from bu4.parsing.targets.aplambda import APLambda


class XMake(Extension, code=CODE_MAKE):
    def apply(self, state: AfterParsing) -> ParsingState:
        name = self.parser.parse_name()
        state.state = AfterParsing(
            ParsingRead(),
            APLambda(
                lambda value: ParsingFinished(PLambda(name, value))
            )
        )
        return state
