#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.parsing.codes import CODE_QUOT
from bu4.parsing.extensions.extension import Extension
from bu4.parsing.states.parsingstate import ParsingState
from bu4.parsing.states.afterparsing import AfterParsing
from bu4.parsing.targets.apchain import APChain
from bu4.parsing.targets.apendswith import APEndsWith

__all__ = ('XQuot',)


class XQuot(Extension, code=CODE_QUOT):
    def apply(self, state: AfterParsing) -> ParsingState:
        state.target = APChain(APEndsWith(self.parser, CODE_QUOT, 'quot expected'), state.target)
        return state
