#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.parsing.abstractparser import AbstractParser
from bu4.parsing.constructs.parsed import Parsed
from bu4.parsing.states.parsingstate import ParsingState
from bu4.parsing.states.parsingfinished import ParsingFinished
from bu4.parsing.targets.aptarget import APTarget

__all__ = ('APEndsWith',)


class APEndsWith(APTarget):
    def __init__(self, parser: AbstractParser, expected: int, message: str):
        self.parser = parser
        self.expected = expected
        self.message = message

    def given(self, parsed: Parsed) -> ParsingState:
        assert self.parser.read() == self.expected, self.message
        return ParsingFinished(parsed)
